function [Ome]=fESPRIT(x,K)
% x - analyzed signal
% K - assumed number of real damped sines
N = length(x);                     % number of samples
L = 2*K;                           % prediction order, number of complex components
L1 = L+1;
r=xcorr(x,'unbiased');             % choose: 'unbiased', 'biased', 'coeff', 'none'
r = r(N:end);                      % auto-correlation vector ryy
R0 = toeplitz( r(1:L+1) );         % auto-correlation matrix Ry0y0
R1 = [ R0(:,2:L1) r(L1+1:-1:2)'];  % auto-correlation matrix Ry0y1
[V,D] = eig(R0);                   % EVD( Ry0y0 )
sigma = min(diag(D));              % minimum eigen value
I = eye(L1); J = [zeros(1,L1); I(1:L1-1,1:L1) ];  % matrices I, J
C0 = R0 - sigma*I; C1 = R1 - sigma*J;             % matrices C0= Cy0y0. C1=Cy0y1
S = eig(C0, C1);                                  % EVD( C0, C1) - Matrix-Pencil
S = S( find( abs(S) > 0.5 ) );     % find complex values with magnitudes > 0.5
Om = atan2( imag(S), real(S) );    % complex value angles
Om = sort( Om, 'descend' ); Ome = Om(1:K); % complex value pulsations