function [ Om ]=fPisarenko(x,K,C)
% x - analyzed signal  sum of damped sinusoids
% K - assumed number of real damped sines
% C  autocorrelation method estimation (1, 2, 3 or 4)
N = length(x);                              % signal length
L = 2*K;                                    % signal subspace, 2K components
if( C==1 ) R=xcorr(x,'biased'); end         % autocorrelation function
if( C==2 ) R=xcorr(x,'unbiased'); end       %
if( C==3 ) R=xcorr(x,'coeff'); end          %
if( C==4 ) R=xcorr(x,'none'); end           % choose this option
R = R(N:end);                               % only right part due to symmetry
RR = toeplitz( R(1:L+1) );                  % Toeplitz matrix
[V,D] = eig(RR);                            % EVD
[Dmin indx] = min(diag(D));                 % minimum eigen-value and its index
a = V(:,indx).';                            % minimum eigen-vector
z = roots(a); p = log(z); Om = imag(p);     % roots of polynomial, then ln()
Om = sort( Om, 'descend' ); Om = Om(1:K);   % found radial frequencies
