function [Om, D]=fProny(x,K)
% x - analyzed signal - sum of damped sinusoids
% K - assumed number of real damped sines (calling choose 
N = length(x);                             % number of samples
P = 2*K;                                   % prediction order
M = N-P;                                   % max number of equations
FirstCol = x(1:M); LastRow = x(M:M+P-1);   % for Hankel type matrix 
Y = hankel( FirstCol, LastRow );           % matrix MxL
y = x(P+1:P+M).';                          % vector Mx1
%a = -pinv(Y)*y;                           % classical solution
a = -Y\y;                                  % Matlab optimized  solution 
p = log( roots( [1 fliplr(a')] ) );        % polynomial roots
Om = imag(p); [Om indx] = sort( Om, 'ascend' ); Om = Om(K+1:2*K); % pulsation
D = -real( p(indx(K+1:2*K)) );                                    % damping
