function [Om, D]=fYuleWalker(x,K,C)
% x - analyzed signal
% K - assumed number of real damped sines
% C - autocorrelation estimation method (choose 1,2,3 or 4)
N = length(x);                              % signal length
L = 2*K;                                    % prediction order
M = N-L;                                    % max numer of equations
if( C==1 ) r=xcorr(x,'biased');   end       %
if( C==2 ) r=xcorr(x,'unbiased'); end       %
if( C==3 ) r=xcorr(x,'coeff');    end       %
if( C==4 ) r=xcorr(x,'none');     end       % choose this option
R = r(N:end);                               % take only right part (symmetry)
FirstCol = R(1:M); LastRow = R(M:M+L-1);    % 
Y = hankel( FirstCol, LastRow );            % matrix MxL
y = R(L+1:L+M).';                           % vector Mx1
a = -Y\y; % a = -pinv(Y)*y;                 % solving linear equation
p = log(roots( [1 fliplr(a.')] ));          % roots, ln() 
Om = imag(p); [Om indx] = sort( Om, 'ascend' );  Om=Om(K+1:2*K); % pulsation
D = -real(p(indx(K+1:2*K)));                                      % damping
