% lab13_ex_evd_signals.m - EVD of signal auto-correlation matrix
clear all; close all;

%% Sinal parameter
N = 500;	% number of samples
K = 4;		% number of signal components used, 1,2,3 or 4
SNR = 60;	% signal to noise ratio in [dB], from  20 to 160
 
Om = [12.345 77.89 111.22 145.67 ]*(2*pi)/N,    % radial frequencies
%D  = [0.001 0.01 0.10 0.20 ],	                % dampings
D = [ 0 0 0 0 ], 		                        % no damping for fPisarenko method
A = [4.3  3.3  2.3  1.3  ]; 		            % amplitudes
p = [-pi/11 -pi/7 -pi/5 -pi/3]; 	            % phase shifts

%% Generation of test signal
n = 0:N-1; x = zeros(1,N);
for k = 1 : K
    x = x + A(k) * exp( -n*D(k) ).*cos( Om(k)*n + p(k) );
end
y = awgn( x, SNR);		                        % addition of noise
figure; plot(y); title('Analyzed signal'); xlabel('n'); grid; pause
 
%% Signal auto-correlation and its EVD decomposition
L = 2*K+20;			            % order of auto-correlation matrix 
ryy = xcorr(y,'biased');        % unbiased, biased, coeff, none
ryy = ryy(N:end);		        % due to symmetry, half is enough
Ryy = toeplitz( ryy(1:L+1) );	% buildig Ryy matrix
[V, D ] = eig( Ryy );		    % EVD( Ryy )
sigma = diag( D );              % sigular values
[sigma, indx] = sort( sigma, 'descend' );  % first 2K eigenvalues should be bigger 
figure; stem( sigma ), title('Eigen values \delta (k)'); grid, pause
figure                                     % coresponding eigenvectors
subplot(421); plot(V(:,indx(1))), title('Eigen-vector #1'); grid,
subplot(423); plot(V(:,indx(2))), title('Eigen-vector #2'); grid,
subplot(425); plot(V(:,indx(3))), title('Eigen-vector #3'); grid,
subplot(427); plot(V(:,indx(4))), title('Eigen-vector #4'); grid,
subplot(422); plot(V(:,indx(5))), title('Eigen-vector #5'); grid,
subplot(424); plot(V(:,indx(6))), title('Eigen-vector #6'); grid,
subplot(426); plot(V(:,indx(7))), title('Eigen-vector #7'); grid,
subplot(428); plot(V(:,indx(8))), title('Eigen-vector #8'); grid,
pause
ortho = V(:,2)'*V(:,5),  % example: should be 0 (orthogonal)
norm  = V(:,2)'*V(:,2),  % example: should be 1 (unitary, normalized)
