% lab13_ex_instrument_tuning.m
% finding frequencies of musical instrument harmonics  
clear all; close all;

% Read signal
[ x, fs ] = audioread('piano.wav');  % 'piano.wav', 'guitar.wav', 'bell.wav'
x = x(:,1); N = length(x), fs, pause
x = x';
dt=1/fs; t=dt*(0:N-1);
%x = sin(2*pi*1000*t); % for testing
figure; plot(t,x,'b.-'); grid; xlabel('t [s]'); title('x(t)'); pause   % signal shape

% Calculate its Fourier spectrum
[dummy,indx] = max(x);
Nfft = min(N,2^13); df=fs/Nfft; f=df*(0:Nfft-1); k=1:Nfft/2+1;
XdB = 20*log10( abs(fft( x(indx:indx+Nfft-1) )/Nfft) );
figure; plot( k, XdB(k), 'b.-'); grid; xlabel('DFT bin k'); title('|X(f)| [dB]'); pause 
figure; plot( f(k), XdB(k), 'b.-'); grid; xlabel('f [Hz]'); title('|X(f)| [dB]'); pause 
df=1; f =df*(0:5000); Nf=2048;
% figure; spectrogram(x,Nf,Nf-128,f,fs); pause  % Matlab (new)
specgram(x,Nf,fs,Nf,Nf-128); pause % Octave and Matlab (old)

% Find frequency of the DFT spectrum maximum using interpolated DFT (IpDFT)
NI=0; [Om, D, A, p] = fIpDFT_BY1_LC( x(indx:indx+Nfft-1), NI );
festim = Om/(2*pi)*fs,
