% lab13_ex_real_spectroscopy.m - signals from mechanical spectroscopy
% K. Duda, L.B. Magalas, M. Majewski, T. Zielinski: "DFT-based Estimation
% of Damped Oscillation Parameters in Low-Frequency Mechanical
% Spectroscopy", IEEE Trans. on Instrumentation and Measurement, vol. 60
% (2011), no.11, pp. 3608-3618.
% In Octave load the function awgn(): >>pkg load communications[ENTER]
clear all; close all;

% Mechanical spectroscopy
SNR = 38;                          % approximatelly
delta = 0.1;                       % 0.0001 - 0.1
f0 = 1.01;                         % 0.15 - 9.55 Hz
fs = 1000; dt=1/fs; N = 30*fs;  A=4.5; phi=pi/7;
D = delta*f0/fs, Om = 2*pi*f0/fs, pause
n = 0:N-1;
x = A*exp(-D*n) .* cos(Om*n+phi);  % first signal equation (A,D,Om,phi)
figure; plot(n*dt,x,'b.-'); grid; xlabel('t [s]'); title('Damped sine'); pause

% Noise addition
x = awgn( x, SNR, 'measured');     % in Octave: >>pkg load communications[ENTER]
figure; plot(n*dt,x,'b-'); grid; xlabel('t [s]'); title('Damped sine with noise'); pause
