% lab13_ex_svd_image.m - SVD-based image decomposition, analysis and synthesis
% Thanks to dr Tomasz Twardowski
clear all; close all;

[X,map] = imread('lena512.bmp');             % read image
X = double(X);                               % change number represetation
figure; image(X); title('Our image');        % display image
colormap(map); axis image off; pause         % 

[U,S,V] = svd(X);                            % perform image SVD
figure; image( U*S*V' ); title('SVD');       % show reconstructed result
colormap(map); axis image off; pause         % color map
mv = [1, 2, 3, 4, 5, 10, 15, 20, 25, 50];    % number of added rank-one images
for i = 1 : length(mv)                       % add approximation matrices in a loop
    many = mv(i),                            % how many rank-one images to add
    mask = zeros(size(S));                   % masking matrix
    mask( 1:mv(i), 1:mv(i) ) = 1;            % with 1s only on main diag beginning
    figure; image( U * (S.*mask) * V' );     % masking, reconstruction, image display 
    colormap(map); axis image off;           % color map
    pause
end
